## kmymoney 5.0.3

=== CMakeLists.txt ===
# The CMake version we require
cmake_minimum_required(VERSION 3.1)

# Setting the name of the main project
project(KMyMoney VERSION "5.0.3" LANGUAGES CXX)

# Determine the GIT reference (if we're based on GIT)
if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/.git")
  execute_process(COMMAND git rev-parse --short HEAD WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}" OUTPUT_VARIABLE VERSION_SUFFIX OUTPUT_STRIP_TRAILING_WHITESPACE)
  set(VERSION_SUFFIX "-${VERSION_SUFFIX}")
  # Add variables which are similar to the build in names of cmake
  set(PROJECT_VERSION_SUFFIX "${VERSION_SUFFIX}")
  set(${PROJECT_NAME}_VERSION_SUFFIX "${VERSION_SUFFIX}")
endif()

# Automoc all sources
set(CMAKE_AUTOMOC TRUE)
list(APPEND CMAKE_AUTOMOC_MACRO_NAMES "K_PLUGIN_FACTORY" "K_PLUGIN_FACTORY_WITH_JSON")

if (POLICY CMP0063)
  cmake_policy(SET CMP0063 NEW) # Policy introduced in CMake version 3.3
endif()
if (POLICY CMP0071)
  # We do not require the old behaviour. It is only set to old, to prevent accidential use of
  # the new behavour. If the new behaviour becomes important, cmake_minimum_required has to be
  # set to "3.10".
  cmake_policy(SET CMP0071 OLD) # Policy introduced in CMake version 3.10
endif()


######################### General Requirements ##########################

if (CMAKE_COMPILER_IS_GNUCXX AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 6.0.0)
    message(FATAL_ERROR "This version of KMyMoney requires at least gcc 6.0.0 to be built successfully")
endif()

find_package(ECM 5.10 REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH} ${ECM_KDE_MODULE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)

include(KDEInstallDirs)
include(KDECMakeSettings)
include(FeatureSummary)
include(CMakeDependentOption)

include(GenerateExportHeader)
include(KMyMoneyMacros)

find_package(PkgConfig)

set (OPT_KF5_COMPONENTS DocTools Holidays Contacts Akonadi IdentityManagement Activities)
find_package(Gpgmepp)
if (Gpgmepp_FOUND)
  set(GPG_ENCRYPTION ON)
else()
  set(GPG_ENCRYPTION OFF)
  list(APPEND OPT_KF5_COMPONENTS Gpgmepp)
endif()

if (PkgConfig_FOUND)
  pkg_check_modules(SQLCIPHER sqlcipher)
endif()

find_package(Qt5 5.6 REQUIRED
  COMPONENTS Core DBus Widgets Svg Xml Test PrintSupport
  OPTIONAL_COMPONENTS Sql Concurrent QuickWidgets)

find_package(KF5 5.2 REQUIRED
  COMPONENTS Archive CoreAddons Config ConfigWidgets I18n Completion KCMUtils ItemModels ItemViews Service Wallet IconThemes XmlGui TextWidgets Notifications KIO
  OPTIONAL_COMPONENTS ${OPT_KF5_COMPONENTS}
)

if(LibAlkimia5_DIR)
  set(_LibAlkimia5_DIR ${LibAlkimia5_DIR})
endif()
find_package(LibAlkimia5 8.0)
if (NOT LibAlkimia5_FOUND)
  # restore LibAlkimia5_DIR set to NOTFOUND by first find_package call
  if(_LibAlkimia5_DIR)
    set(LibAlkimia5_DIR ${_LibAlkimia5_DIR})
  endif()
  find_package(LibAlkimia5 7.0 REQUIRED)
endif()
# Recent changes to LibAlkimia should allow us to remove this construct
#if(CMAKE_SYSTEM_NAME MATCHES "Windows")
#  include_directories(${GMP_INCLUDE_DIR})
#endif()

find_package(KChart 2.6.0 REQUIRED)

if(KF5Gpgmepp_FOUND)
  set(GPG_ENCRYPTION ON)
  add_definitions(-DGpgmepp_FOUND)
endif()

add_feature_info("Encryption" GPG_ENCRYPTION "It allows encrypting your financial data.")

add_definitions(-DQT_USE_QSTRINGBUILDER -DQT_NO_CAST_TO_ASCII -DQT_NO_URL_CAST_FROM_STRING)
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# use DBus only on Linux
if(CMAKE_SYSTEM_NAME MATCHES "Linux")
  set(KMM_DBUS 1)
endif()

set(CMAKE_INCLUDE_CURRENT_DIR ON)
include_directories(${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR})

# check for Doxygen
find_package(Doxygen)
if(DOXYGEN_FOUND)
  set(APIDOC_DIR ${CMAKE_CURRENT_BINARY_DIR}/apidocs)

  make_directory("${APIDOC_DIR}")
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/kmymoney.doxygen.in ${CMAKE_CURRENT_BINARY_DIR}/kmymoney.doxygen IMMEDIATE)

  add_custom_target(apidoc "${DOXYGEN}" "${CMAKE_CURRENT_BINARY_DIR}/kmymoney.doxygen")
endif(DOXYGEN_FOUND)
add_feature_info("Doxygen" DOXYGEN_FOUND "Generate API documentation with Doxygen (for devs only).")

# check some include files exists
set(CMAKE_REQUIRED_DEFINITIONS -D_XOPEN_SOURCE=500 -D_BSD_SOURCE)
include (CheckIncludeFileCXX)
check_include_file_cxx("unistd.h" HAVE_UNISTD_H)
check_include_file_cxx("pwd.h" HAVE_PWD_H)
check_include_file_cxx("windows.h" HAVE_WINDOWS_H)
check_include_file_cxx("lmcons.h" HAVE_LMCONS_H)
check_include_file_cxx("process.h" HAVE_PROCESS_H)

# include check for members in structs
include (CheckStructHasMember)

######################### Special Requirements ##########################

# This is needed for QtSqlite and QtDesigner
# (they'll install files to ${QT_INSTALL_DIR}/plugins/)
get_filename_component(QT_BIN_DIR "${QT_MOC_EXECUTABLE}" PATH)
get_filename_component(QT_DIR     ${QT_BIN_DIR}        PATH)
set(QT_INSTALL_DIR ${QT_DIR} CACHE PATH
  "Qt install prefix defaults to the Qt prefix: ${QT_DIR}")

if(KF5IdentityManagement_FOUND AND KF5Akonadi_FOUND AND KF5Contacts_FOUND)
  set(KMM_ADDRESSBOOK_FOUND true)
endif()

add_feature_info("Address book" KMM_ADDRESSBOOK_FOUND "It allows fetching payee information from KDE PIM system.")
add_feature_info("Holidays" KF5Holidays_FOUND "It allows fetching holidays from KDE PIM system.")

option(ENABLE_FORECASTVIEW "Enable forecast view" ON)
add_feature_info("Forecast view" ENABLE_FORECASTVIEW "It adds possibility to calculate forecasts.")
option(ENABLE_REPORTSVIEW "Enable reports view" ON)
add_feature_info("Reports view" ENABLE_REPORTSVIEW "It adds possibility to display chart and table reports.")
option(ENABLE_BUDGETVIEW "Enable budget view" ON)
add_feature_info("Budget view" ENABLE_BUDGETVIEW "It adds possibility to plan a budget.")
option(ENABLE_ONLINEJOBOUTBOXVIEW "Enable online job outbox view" ON)
add_feature_info("Online job outbox view" ENABLE_ONLINEJOBOUTBOXVIEW "It adds outbox for sending online jobs.")

cmake_dependent_option(ENABLE_SQLSTORAGE "Enable SQL storage support." ON
                       "Qt5Sql_FOUND" OFF)

add_feature_info("SQL Storage" ENABLE_SQLSTORAGE "It allows storing your financial data in SQL database.")

cmake_dependent_option(ENABLE_SQLCIPHER "Enable SQLCipher support." ON
                       "SQLCIPHER_FOUND" OFF)

# Otherwise compilers halt on something like that:
# ld: library not found for -lsqlcipher
# on MS Windows, FreeBSD, and macOS.
if(ENABLE_SQLCIPHER AND NOT CMAKE_SYSTEM_NAME MATCHES "Linux")
  link_directories(${SQLCIPHER_LIBRARY_DIRS})
endif()

add_feature_info("SQLCipher" ENABLE_SQLCIPHER "It allows encrypting your SQLite3 database.")

cmake_dependent_option(ENABLE_IBANBICDATA "Enable IBAN/BIC data support." OFF
                       "Qt5Sql_FOUND" OFF)

add_feature_info("IBAN/BIC data" ENABLE_IBANBICDATA "Adds predefined IBAN/BIC numbers to KMyMoney (note: doesn't work yet).")

# check for optional QWebEngine
option(ENABLE_WEBENGINE "Enable QWebEngine" OFF)
if(ENABLE_WEBENGINE)
  find_package(Qt5WebEngineWidgets 5.8 REQUIRED)
  if(Qt5WebEngineWidgets_VERSION VERSION_GREATER 5.8.99 AND Qt5WebEngineWidgets_VERSION VERSION_LESS 5.9.3)
    message(WARNING "QWebEngine version ${Qt5WebEngineWidgets_VERSION} is known to be unstable with KMyMoney")
  endif()
else(ENABLE_WEBENGINE)
  find_package(KF5WebKit REQUIRED)
endif(ENABLE_WEBENGINE)

# check for optional LibOFX support
find_package(LibOfx)
cmake_dependent_option(ENABLE_OFXIMPORTER "Enable OFX Importer" ON
                       "LIBOFX_FOUND" OFF)

if(ENABLE_OFXIMPORTER)
  if(NOT LIBOFX_HAVE_CLIENTUID)
    set(PATH_TO_LIBOFX_HEADER "${LIBOFX_INCLUDE_DIR}/libofx/libofx.h")
    unset(LIBOFX_HAVE_CLIENTUID)
    unset(LIBOFX_HAVE_CLIENTUID CACHE) #not doing this will prevent updating below check
    check_struct_has_member("struct OfxFiLogin" clientuid ${PATH_TO_LIBOFX_HEADER} LIBOFX_HAVE_CLIENTUID LANGUAGE CXX)
  endif()

  if (LIBOFX_HAVE_CLIENTUID)
    set (nice_LIBOFX_HAVE_CLIENTUID "yes")
  else()
    set (nice_LIBOFX_HAVE_CLIENTUID "no")
  endif()

else()
  set (nice_LIBOFX_HAVE_CLIENTUID "unknown")
  unset(LIBOFX_HAVE_CLIENTUID)
  unset(LIBOFX_HAVE_CLIENTUID CACHE)
endif(ENABLE_OFXIMPORTER)

add_feature_info("OFX Importer" ENABLE_OFXIMPORTER "It allows importing OFX files (have client uid version: ${nice_LIBOFX_HAVE_CLIENTUID})" )

# check for optional KBanking support
find_package(AQBANKING 5.6.5)
find_package(gwenhywfar 4.15.3)
find_package(gwengui-cpp)
find_package(gwengui-qt5)

cmake_dependent_option(ENABLE_KBANKING "Enable KBanking plugin" ON
                       "AQBANKING_FOUND;gwengui-cpp_FOUND;gwengui-qt5_FOUND;Qt5QuickWidgets_FOUND" OFF)

add_feature_info(KBanking ENABLE_KBANKING "Interface for the following online banking protocols: HBCI, EBICS, OFX Direct Connect, Paypal")

# check for optional Weboob support
set(Python_ADDITIONAL_VERSIONS 2.7 2.6)
find_package(PythonInterp 2.6)
find_package(PythonLibs ${PYTHON_VERSION_STRING})

if(PYTHONINTERP_FOUND AND PYTHONLIBS_FOUND)
  if(NOT PYTHON_VERSION_MAJOR VERSION_LESS 3)
    unset(PYTHONLIBS_FOUND)
    unset(PYTHONINTERP_FOUND)
    message(WARNING "Python 2 required, but Python 3 found.")
  else()
    include(FindPythonModule)
    find_python_module(weboob REQUIRED)
  endif()
endif()

cmake_dependent_option(ENABLE_WEBOOB "Enable Weboob plugin" ON
                       "PYTHONLIBS_FOUND;PYTHONINTERP_FOUND;PY_WEBOOB;Qt5Concurrent_FOUND" OFF)
add_feature_info(Weboob ENABLE_WEBOOB "Online banking interface using Weboob.")


# check for optional ical support
find_package(Libical)
cmake_dependent_option(ENABLE_LIBICAL "Enable Calendar plugin" ON
                       "LIBICAL_FOUND" OFF)
add_feature_info(iCalendar ENABLE_LIBICAL "iCalendar integration.")


option(ENABLE_QIFIMPORTER "Enable QIF Importer" ON)
option(ENABLE_QIFEXPORTER "Enable QIF Exporter" ON)
add_feature_info("QIF Importer" ENABLE_QIFIMPORTER "It allows importing QIF files.")
add_feature_info("QIF Exporter" ENABLE_QIFEXPORTER "It allows exporting QIF files.")

option(ENABLE_GNCIMPORTER "Enable GNC Importer" ON)
add_feature_info("GNC Importer" ENABLE_GNCIMPORTER "It allows importing GNUCash files.")

option(ENABLE_CSVIMPORTER "Enable CSV Importer" ON)
option(ENABLE_CSVEXPORTER "Enable CSV Exporter" ON)
add_feature_info("CSV Importer" ENABLE_CSVIMPORTER "It allows importing CSV files.")
add_feature_info("CSV Exporter" ENABLE_CSVEXPORTER "It allows exporting CSV files.")

option(ENABLE_UNFINISHEDFEATURES "For devs only" OFF)

# TODO: this should be removed
enable_testing()

######################### Settings ##########################

# If no build type is set, use "Release with Debug Info"
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif(NOT CMAKE_BUILD_TYPE)

set(CMAKE_BUILD_TYPE "${CMAKE_BUILD_TYPE}" CACHE STRING
  "Choose the type of build.
Possible values are: 'Release' 'RelWithDebInfo' 'Debug' 'DebugKMM' 'Debugfull' 'Profile'
The default value is: 'RelWithDebInfo'" FORCE)

# tells gcc to enable exception handling
include(KDECompilerSettings)
kde_enable_exceptions()

# Set linker flags

# There is no way to detect linker in cmake (see https://gitlab.kitware.com/cmake/cmake/issues/17596)
# and linkers aren't compatible with each other, so we need to assume something
if(CMAKE_CXX_COMPILER_ID MATCHES "AppleClang")
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,-dead_strip -Wl,-undefined,error")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-dead_strip -Wl,-undefined,error -Wl,-mark_dead_strippable_dylib")
  set(CMAKE_EXE_LINKER_FLAGS    "${CMAKE_EXE_LINKER_FLAGS}    -Wl,-dead_strip -Wl,-undefined,error")

elseif(CMAKE_CXX_COMPILER_ID MATCHES "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--as-needed")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--as-needed")
  # TODO: remove multiple definitions of payeeIdentifierLoader::createPayeeIdentifierFromSqlDatabase

=== 3rdparty/ext_gnutls/CMakeLists.txt ===
ExternalProject_Add(
  ext_gnutls
  DOWNLOAD_DIR ${EXT_DOWNLOAD_DIR}
  URL https://www.gnupg.org/ftp/gcrypt/gnutls/v3.6/gnutls-3.6.4.tar.xz
  URL_MD5 63363d1c00601f4d11a5cadc8b5e0799

  CONFIGURE_COMMAND <SOURCE_DIR>/configure --prefix=${EXT_INSTALL_DIR} ${AT_HOST} ${AT_SHARED_ONLY} --disable-tests --disable-doc --enable-openssl-compatibility -disable-gtk-doc --enable-cxx --without-p11-kit CPPFLAGS=${AT_CPP_FLAGS} LDFLAGS=${AT_LD_FLAGS}
  BUILD_COMMAND $(MAKE)
  INSTALL_COMMAND $(MAKE) install

  DEPENDS ext_assuan2 ext_gpgerror ext_nettle ext_tasn1 ext_unistring
)

=== 3rdparty/ext_gwenhywfar/CMakeLists.txt ===
set(gwenhywfar_guis "qt5 cpp")

ExternalProject_Add(
  ext_gwenhywfar
  DOWNLOAD_DIR ${EXT_DOWNLOAD_DIR}
  URL https://www.aquamaniac.de/sites/download/download.php?package=01&release=208&file=02&dummy=gwenhywfar-4.20.0.tar.gz
  URL_MD5 0744255cae68adca6dff81d3a9f3932d

  CONFIGURE_COMMAND <SOURCE_DIR>/configure --prefix=${EXT_INSTALL_DIR} ${AT_SHARED_ONLY} --with-guis=${gwenhywfar_guis} CPPFLAGS=${AT_CPP_FLAGS} LDFLAGS=${AT_LD_FLAGS}
  BUILD_COMMAND $(MAKE)
  INSTALL_COMMAND $(MAKE) install

  DEPENDS ext_gnutls ext_gcrypt
)

=== 3rdparty/ext_mysql/CMakeLists.txt ===
ExternalProject_Add(
  ext_mysql
  DOWNLOAD_DIR ${EXT_DOWNLOAD_DIR}
  URL https://cdn.mysql.com//Downloads/MySQL-8.0/mysql-boost-8.0.12.tar.gz
  URL_MD5 82ba7cc22755f77635768c6e6d184161

  CMAKE_ARGS ${CMAKE_GLOBAL_PROFILE}
              -DWITH_BOOST=<SOURCE_DIR>/boost
              -DBUILD_CONFIG=mysql_release
              -DWITH_LZMA=system
              -DWITH_ICU=system
              -DINSTALL_STATIC_LIBRARIES=OFF
#               -DCPACK_MONOLITHIC_INSTALL=1
#               -DIGNORE_AIO_CHECK=1


  BUILD_COMMAND "" # on default whole server would be built
  INSTALL_COMMAND ""
  DEPENDS ext_ncurses ext_openssl
)

# build and install client only
ExternalProject_Add_Step(
ext_mysql client
COMMAND ${CMAKE_MAKE_PROGRAM}
COMMAND ${CMAKE_MAKE_PROGRAM} install
DEPENDEES install
WORKING_DIRECTORY <BINARY_DIR>/libmysql
)

ExternalProject_Add_Step(
ext_mysql scripts
COMMAND ${CMAKE_MAKE_PROGRAM}
COMMAND ${CMAKE_MAKE_PROGRAM} install
DEPENDEES client
WORKING_DIRECTORY <BINARY_DIR>/scripts
)

# build and install headers
ExternalProject_Add_Step(
ext_mysql headers
COMMAND ${CMAKE_MAKE_PROGRAM}
COMMAND ${CMAKE_MAKE_PROGRAM} install
DEPENDEES scripts
WORKING_DIRECTORY <BINARY_DIR>/include)

=== 3rdparty/ext_xml/CMakeLists.txt ===
# --without-catalog is requirement of QWebEngine
ExternalProject_Add(
  ext_xml
  DOWNLOAD_DIR ${EXT_DOWNLOAD_DIR}
  URL ftp://xmlsoft.org/libxslt/libxml2-2.9.8.tar.gz
  URL_MD5 b786e353e2aa1b872d70d5d1ca0c740d

  PATCH_COMMAND ${PATCH_COMMAND} -p1 -i ${CMAKE_CURRENT_SOURCE_DIR}/xml.diff

  CONFIGURE_COMMAND <SOURCE_DIR>/configure --prefix=${EXT_INSTALL_DIR} ${AT_HOST} --without-python --with-icu --without-catalog --with-lzma=${EXT_INSTALL_DIR}/lib CPPFLAGS=${AT_CPP_FLAGS} LDFLAGS=${AT_LD_FLAGS}
  BUILD_COMMAND $(MAKE)
  INSTALL_COMMAND $(MAKE) install
  DEPENDS ext_lzma ext_readline ext_icu
)

=== kmymoney/misc/CMakeLists.txt ===
install(PROGRAMS financequote.pl
        DESTINATION ${DATA_INSTALL_DIR}/kmymoney/misc)

set( kmm_utils_validators_SRCS
  charvalidator.cpp
  validators.cpp
)

set( kmm_utils_webconnect_SRCS
  webconnect.cpp
)

if( "${HAVE_UNISTD_H}" AND "${HAVE_PWD_H}" )
  set( kmm_utils_platformtools_SRCS
    platformtools_gnu.cpp
  )
elseif( "${HAVE_WINDOWS_H}" AND "${HAVE_LMCONS_H}" AND "${HAVE_PROCESS_H}" )
  set( kmm_utils_platformtools_SRCS
    platformtools_nognu.cpp
  )
else()
  message(FATAL_ERROR "make sure either windows.h and lmcons.h (on msvc platforms) or unistd.h and pwd.h (on other platforms) are present.")
endif()

set( kmm_utils_validators_HEADER
  charvalidator.h
  validators.h
)

set( kmm_utils_webconnect_HEADER
  webconnect.h
)

set( kmm_utils_platformtools_HEADER
  platformtools.h
)

add_library(kmm_utils_validators STATIC ${kmm_utils_validators_SRCS})
add_library(kmm_utils_webconnect STATIC ${kmm_utils_webconnect_SRCS})
add_library(kmm_utils_platformtools STATIC ${kmm_utils_platformtools_SRCS})

target_link_libraries( kmm_utils_validators
  PUBLIC
  Qt5::Core
  Qt5::Gui
)

target_link_libraries( kmm_utils_webconnect
  PUBLIC
  Qt5::Core
  Qt5::Network
)

target_link_libraries( kmm_utils_platformtools
  PUBLIC
  Qt5::Core
)

=== kmymoney/plugins/CMakeLists.txt ===
add_subdirectory( onlinetasks )
add_subdirectory( interfaces )
add_subdirectory( csv )
add_subdirectory( qif )
add_subdirectory( gnc )
add_subdirectory( ofx )
add_subdirectory( icalendar )
add_subdirectory( reconciliationreport )
add_subdirectory( checkprinting )
add_subdirectory( views )

if(ENABLE_SQLSTORAGE OR ENABLE_XMLSTORAGE)
  add_subdirectory(xmlhelper)
endif()

if(ENABLE_SQLSTORAGE)
  add_subdirectory(sql)
endif()

# if(ENABLE_XMLSTORAGE OR BUILD_TESTING)
  add_subdirectory(xml)
# endif()

if(ENABLE_IBANBICDATA)
  add_subdirectory(ibanbicdata)
endif()

if (ENABLE_KBANKING)
  add_subdirectory( kbanking )
endif (ENABLE_KBANKING)

if (ENABLE_SQLCIPHER)
  add_subdirectory(sqlcipher)
endif()

option(ENABLE_ONLINEJOBPLUGINMOCKUP "Enable onlineJob-plugin mockup (only for developers)" OFF)
if (ENABLE_ONLINEJOBPLUGINMOCKUP)
  add_subdirectory(onlinejobpluginmockup)
endif()

if (ENABLE_WEBOOB)
  add_subdirectory( weboob )
endif ()

########### next target ###############

set(kmm_plugin_LIB_SRCS
  appinterface.cpp
  importinterface.cpp
  kmymoneyplugin.cpp
  statementinterface.cpp
  viewinterface.cpp
  onlinepluginextended.cpp
  interfaceloader.cpp
)

set(plugin_HEADERS
  appinterface.h
  importinterface.h
  kmymoneyplugin.h
  statementinterface.h
  viewinterface.h
  ${CMAKE_CURRENT_BINARY_DIR}/kmm_plugin_export.h
  onlinepluginextended.h
)

add_library(kmm_plugin SHARED ${kmm_plugin_LIB_SRCS})
generate_export_header(kmm_plugin BASE_NAME kmm_plugin)
target_link_libraries(kmm_plugin
  PUBLIC
    Qt5::Core
    KF5::XmlGui
  PRIVATE
    KF5::KCMUtils
    KF5::KIOWidgets
    Qt5::Gui
    Qt5::Widgets
  INTERFACE
    kmm_mymoney
)

set_target_properties(kmm_plugin PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR})

########### install files ###############

install(TARGETS kmm_plugin
  ${INSTALL_TARGETS_DEFAULT_ARGS} )

install(FILES ${plugin_HEADERS}
  DESTINATION ${INCLUDE_INSTALL_DIR}/kmymoney  COMPONENT Devel)

install(FILES
  kmymoney-payeeidentifierdelegate.desktop
  kmymoney-importerplugin.desktop
  DESTINATION ${SERVICETYPES_INSTALL_DIR}
)

=== kmymoney/views/CMakeLists.txt ===
############# next target (views) STATIC ###################
set(libviews_a_SOURCES
  kaccountsview.cpp
  kcategoriesview.cpp
  kgloballedgerview.cpp
  kwelcomepage.cpp
  khomeview.cpp
  kinstitutionsview.cpp
  kinvestmentview.cpp
  kmymoneyfile.cpp
  kmymoneyview.cpp
  kpayeesview.cpp
  kscheduledview.cpp
  kscheduletreeitem.cpp
  ktagsview.cpp
  kpayeeidentifierview.cpp
  payeeidentifierselectiondelegate.cpp
  kmymoneywebpage.cpp
)

if(ENABLE_UNFINISHEDFEATURES)
  list(APPEND libviews_a_SOURCES
    simpleledgerview.cpp
    ledgerviewpage.cpp
    ledgerview.cpp
    ledgerdelegate.cpp
    newspliteditor.cpp
    newtransactioneditor.cpp
    newtransactionform.cpp
    splitdialog.cpp
    splitdelegate.cpp
    widgethintframe.cpp
  )
endif()

set(libviews_a_UI
  kaccountsview.ui
  kcategoriesview.ui
  kinstitutionsview.ui
  kinvestmentview.ui
  kpayeesview.ui
  kscheduledview.ui
  ktagsview.ui
  kpayeeidentifierview.ui
)

if(ENABLE_UNFINISHEDFEATURES)
  list(APPEND libviews_a_UI
    simpleledgerview.ui
    ledgerview.ui
    ledgerviewpage.ui
    splitdialog.ui
    newspliteditor.ui
    newtransactioneditor.ui
    newtransactionform.ui
  )
endif()

# The handling of these ui files depends
# on libkmymoney.so (the widgets library)
ki18n_wrap_ui(libviews_a_SOURCES ${libviews_a_UI})

add_library(views STATIC ${libviews_a_SOURCES})

target_link_libraries(views PUBLIC newaccountwizard KChart KF5::KIOFileWidgets KF5::Notifications KF5::Archive KF5::TextWidgets Qt5::PrintSupport Alkimia::alkimia)

if(ENABLE_WEBENGINE)
 target_link_libraries(views PUBLIC Qt5::WebEngineWidgets)
else(ENABLE_WEBENGINE)
 target_link_libraries(views PUBLIC KF5::WebKit)
endif(ENABLE_WEBENGINE)

# TODO: Remove this dependency. But it is needed as long as the payee editor uses these objects directly
# This should be replaced by virtual methods in a pure abstract object.
target_link_libraries( views PUBLIC
  kmm_mymoney # needed to load payeeIdentifier
  kmm_widgets
)

# we rely on some of the dialogs to be generated
add_dependencies(views dialogs newinvestmentwizard newaccountwizard newloanwizard endingbalancedlg)

=== kmymoney/wizards/CMakeLists.txt ===
include_directories( ${CMAKE_CURRENT_BINARY_DIR}/wizardpages)

add_subdirectory( wizardpages )
add_subdirectory( newuserwizard )
add_subdirectory( newaccountwizard )
add_subdirectory( newinvestmentwizard )
add_subdirectory( newloanwizard )
add_subdirectory( endingbalancedlg )

set(kmymoneywizard_sources
  kmymoneywizard.cpp
  kmymoneywizardpage.cpp
  )

add_library(kmymoneywizard STATIC ${kmymoneywizard_sources})

target_link_libraries(kmymoneywizard KF5::XmlGui KF5::TextWidgets)

=== kmymoney/plugins/checkprinting/CMakeLists.txt ===
# patch the version with the version defined in the build system
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/checkprinting.json.in ${CMAKE_CURRENT_BINARY_DIR}/checkprinting.json @ONLY)

set(checkprinting_PART_SRCS
    numbertowords.cpp
    checkprinting.cpp
    ../../widgets/selectedtransaction.cpp
    )

kconfig_add_kcfg_files(checkprinting_PART_SRCS pluginsettings.kcfgc)

kcoreaddons_add_plugin(checkprinting
                       SOURCES ${checkprinting_PART_SRCS}
                       JSON "${CMAKE_CURRENT_BINARY_DIR}/checkprinting.json"
                       INSTALL_NAMESPACE "kmymoney")

#kcoreaddons_add_plugin sets LIBRARY_OUTPUT_DIRECTORY to ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${INSTALL_NAMESPACE}
set_target_properties(checkprinting
                      PROPERTIES
                      LIBRARY_OUTPUT_DIRECTORY "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}")

target_link_libraries(checkprinting
  Qt5::PrintSupport
  KF5::I18n
  kmm_mymoney
  kmm_plugin
)

if(ENABLE_WEBENGINE)
 target_link_libraries(checkprinting Qt5::WebEngineWidgets)
else(ENABLE_WEBENGINE)
 target_link_libraries(checkprinting KF5::WebKit)
endif(ENABLE_WEBENGINE)

install(FILES checkprinting.rc
        DESTINATION "${KXMLGUI_INSTALL_DIR}/checkprinting")

install(FILES check_template.html
        DESTINATION "${DATA_INSTALL_DIR}/checkprinting")

install(FILES check_template_green_linen.html
        DESTINATION "${DATA_INSTALL_DIR}/checkprinting")

# the KCM module

set(kcm_checkprinting_PART_SRCS
    kcm_checkprinting.cpp
    )

kconfig_add_kcfg_files(kcm_checkprinting_PART_SRCS pluginsettings.kcfgc)

ki18n_wrap_ui(kcm_checkprinting_PART_SRCS pluginsettingsdecl.ui)

kcoreaddons_add_plugin(kcm_checkprinting
                       SOURCES ${kcm_checkprinting_PART_SRCS}
                       JSON "${CMAKE_CURRENT_BINARY_DIR}/kcm_checkprinting.json"
                       INSTALL_NAMESPACE "kmymoney")

kcoreaddons_desktop_to_json(kcm_checkprinting kcm_checkprinting.desktop)

#kcoreaddons_add_plugin sets LIBRARY_OUTPUT_DIRECTORY to ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${INSTALL_NAMESPACE}
set_target_properties(kcm_checkprinting
                      PROPERTIES
                      LIBRARY_OUTPUT_DIRECTORY "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}")

target_link_libraries(kcm_checkprinting
                      Qt5::PrintSupport
                      KF5::I18n
                      KF5::ConfigWidgets
                      KF5::Completion
                      KF5::KIOWidgets
                      KF5::CoreAddons
                      )

if(ENABLE_WEBENGINE)
 target_link_libraries(kcm_checkprinting Qt5::WebEngineWidgets)
else(ENABLE_WEBENGINE)
 target_link_libraries(kcm_checkprinting KF5::WebKit)
endif(ENABLE_WEBENGINE)

install(FILES kcm_checkprinting.desktop
        DESTINATION "${SERVICES_INSTALL_DIR}")

=== kmymoney/plugins/ibanbicdata/CMakeLists.txt ===
#add_subdirectory( germany )
#add_subdirectory( switzerland )
#add_subdirectory( target2 )

# patch the version with the version defined in the build system
configure_file(ibanbicdata.desktop.in ibanbicdata.desktop)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/ibanbicdata.json.in ${CMAKE_CURRENT_BINARY_DIR}/ibanbicdata.json @ONLY)
#kcoreaddons_desktop_to_json(ibanbicdata "${CMAKE_CURRENT_BINARY_DIR}/ibanbicdata.desktop")

set ( IBANBICDATA_SCRS
  ibanbicdata.cpp
  bicmodel.cpp
)

kcoreaddons_add_plugin(ibanbicdata
                       SOURCES ${IBANBICDATA_SCRS}
                       JSON "${CMAKE_CURRENT_BINARY_DIR}/ibanbicdata.json"
                       INSTALL_NAMESPACE "kmymoney")

#kcoreaddons_add_plugin sets LIBRARY_OUTPUT_DIRECTORY to ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${INSTALL_NAMESPACE}
set_target_properties(ibanbicdata
                      PROPERTIES
                      LIBRARY_OUTPUT_DIRECTORY "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}")

target_link_libraries(ibanbicdata
  PUBLIC
    kmm_plugin
  PRIVATE
    Qt5::Sql
    KF5::I18n
)

=== kmymoney/plugins/kbanking/CMakeLists.txt ===
# patch the version with the version defined in the build system
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/kbanking.json.in ${CMAKE_CURRENT_BINARY_DIR}/kbanking.json @ONLY)

add_subdirectory( dialogs )
add_subdirectory( widgets )
add_subdirectory( qml )
add_subdirectory( tasksettings )

set(kbanking_PART_SRCS
    kbanking.cpp
    banking.cpp
    aqbankingkmmoperators.cpp
    gwenhywfarqtoperators.cpp
    gwenkdegui.cpp
)

kconfig_add_kcfg_files(kbanking_PART_SRCS kbankingsettings.kcfgc)

kcoreaddons_add_plugin(kbanking
                       SOURCES ${kbanking_PART_SRCS}
                       JSON "${CMAKE_CURRENT_BINARY_DIR}/kbanking.json"
                       INSTALL_NAMESPACE "kmymoney")

#kcoreaddons_add_plugin sets LIBRARY_OUTPUT_DIRECTORY to ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${INSTALL_NAMESPACE}
set_target_properties(kbanking
                      PROPERTIES
                      LIBRARY_OUTPUT_DIRECTORY "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}")

target_link_libraries(kbanking
                      kbanking_dialogs
                      kbanking_widgets
                      kbanking_tasksettings
                      kmm_mymoney
                      kmm_widgets
                      kmm_plugin
                      KF5::ConfigCore
                      KF5::ConfigGui
                      Qt5::Core
                      Alkimia::alkimia
                      gwenhywfar::core
                      gwenhywfar::gui-cpp
                      gwenhywfar::gui-qt5
                      aqbanking::aqbanking
)

# Add new menu entries if debugging is enabled
set(KMM_BANKING_DEBUG_OPTIONS)
# preprocessor definitions in case this is a debug build
string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_TOLOWER)
if("${CMAKE_BUILD_TYPE_TOLOWER}" MATCHES "debug")
  file(READ kbanking_debug_rc KMM_BANKING_DEBUG_OPTIONS)
endif()
configure_file(kbanking.rc.in "${CMAKE_CURRENT_BINARY_DIR}/kbanking.rc" @ONLY)

########### install files ###############

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/kbanking.rc
        DESTINATION ${KXMLGUI_INSTALL_DIR}/kbanking)

install(FILES kbanking.kcfg
        DESTINATION ${KCFG_INSTALL_DIR})

=== debian/changelog ===
kmymoney (5.0.3-2) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Pino Toscano <pino@debian.org>  Thu, 31 Jan 2019 07:54:01 +0100

kmymoney (5.0.3-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Remove the support for weboob, as it was removed from Debian (see #907199,
    #914179):
    - remove python-weboob as build dependency, and recommend
    - remove the libpython-dev build dependency, no more used by anything else
  * Bump Standards-Version to 4.3.0, no changes required.

 -- Pino Toscano <pino@debian.org>  Tue, 29 Jan 2019 06:50:17 +0100

kmymoney (5.0.2-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Update the patches:
    - upstream_Fix-build-with-Qt-5.11.patch: drop, backported from upstream
  * Add the new required build dependencies: qtbase5-private-dev,
    libsqlcipher-dev, and libsqlite3-dev.
  * Update install files.

 -- Pino Toscano <pino@debian.org>  Mon, 05 Nov 2018 08:49:18 +0100

kmymoney (5.0.1-3) experimental; urgency=medium

  * Team upload.
  * Switch Vcs-* fields to salsa.debian.org.
  * Backport upstream commit e5198a902996b27bf9abde0ad24af82d55ab5dc1 to fix
    build with Qt >= 5.11; patch upstream_Fix-build-with-Qt-5.11.patch.
  * The rebuild will make kmymoney use the new KDE PIM libraries.
    (Closes: #910248)
  * Bump Standards-Version to 4.2.1, no changes required.
  * Switch from --list-missing to dh_missing --fail-missing.
  * Remove empty line at the end of changelog.

 -- Pino Toscano <pino@debian.org>  Sat, 06 Oct 2018 12:07:03 +0200

=== debian/control ===
Source: kmymoney
Section: kde
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Mark Purcell <msp@debian.org>
Build-Depends: debhelper (>= 11), cmake, pkg-kde-tools (>= 0.15.16),
 extra-cmake-modules,
 qtbase5-dev,
 qtbase5-private-dev,
 qtdeclarative5-dev,
 libqt5svg5-dev,
 libkf5activities-dev,
 libkf5akonadi-dev,
 libkf5archive-dev,
 libkf5completion-dev,
 libkf5config-dev,
 libkf5configwidgets-dev,
 libkf5contacts-dev,
 libkf5coreaddons-dev,
 libkf5doctools-dev,
 libkf5holidays-dev,
 libkf5i18n-dev,
 libkf5iconthemes-dev,
 libkf5identitymanagement-dev,
 libkf5itemmodels-dev,
 libkf5itemviews-dev,
 libkchart-dev,
 libkf5kcmutils-dev,
 libkf5kio-dev,
 libkf5notifications-dev,
 libkf5service-dev,
 libkf5textwidgets-dev,
 libkf5wallet-dev,
 libkf5webkit-dev,
 libkf5xmlgui-dev,
 libaqbanking-dev (>= 5.6.1beta),
 libgwenhywfar-core-dev, libgwengui-qt5-dev,
 libgpgmepp-dev, libgpg-error-dev, libgpgme-dev,
 libalkimia5-dev (>= 7.0),
 libical-dev, libofx-dev, libgmp-dev,
 libsqlcipher-dev,
 libsqlite3-dev,
 pkg-config,
Standards-Version: 4.3.0
Homepage: https://kmymoney.org/
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kmymoney
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kmymoney.git

Package: kmymoney
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${aqbanking:Depends}, kmymoney-common (= ${source:Version})
Recommends: gnupg-agent, pinentry-qt | pinentry-x11
Suggests: kcalc
Description: personal finance manager for KDE
 KMyMoney is the Personal Finance Manager for KDE. It operates similar to
 MS-Money and Quicken, supports different account types, categorisation of
 expenses, QIF import/export, multiple currencies and initial online banking
 support.

Package: kmymoney-common
Architecture: all
Depends: ${misc:Depends},
 ${perl:Depends},
Recommends: kmymoney,
 libfinance-quote-perl,
Description: KMyMoney architecture independent files
 KMyMoney is the Personal Finance Manager for KDE. It operates similar to
 MS-Money and Quicken, supports different account types, categorisation of
 expenses, QIF import/export, multiple currencies and initial online banking
 support.
 .
 This package contains architecture independent files needed for KMyMoney to
 run properly. It also provides KMyMoney documentation. Therefore, unless you
 have 'kmymoney' package installed, you will hardly find this package useful.

## kmymoney 5.0.5

=== debian/changelog ===
kmymoney (5.0.5-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Drop the migration from kmymoney-dbg, no more needed after two Debian
    stable releases.
  * Bump Standards-Version to 4.4.0, no changes required.

 -- Pino Toscano <pino@debian.org>  Thu, 11 Jul 2019 05:13:21 +0200

=== debian/control ===
--- 
+++ 
@@ -41,7 +41,7 @@
  libsqlcipher-dev,
  libsqlite3-dev,
  pkg-config,
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Homepage: https://kmymoney.org/
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kmymoney
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kmymoney.git

## kmymoney 5.0.6

=== debian/changelog ===
kmymoney (5.0.6-1) unstable; urgency=medium

  * Team upload.
  * New upstream release. (Closes: #940223)
  * Update the build dependencies according to the upstream build system:
    - bump libaqbanking-dev to 5.8.0
    - bump libgwenhywfar-core-dev, and libgwengui-qt5-dev to 4.20.0

 -- Pino Toscano <pino@debian.org>  Sat, 14 Sep 2019 11:29:45 +0200

=== debian/control ===
--- 
+++ 
@@ -33,8 +33,8 @@
  libkf5wallet-dev,
  libkf5webkit-dev,
  libkf5xmlgui-dev,
- libaqbanking-dev (>= 5.6.1beta),
- libgwenhywfar-core-dev, libgwengui-qt5-dev,
+ libaqbanking-dev (>= 5.8.0~),
+ libgwenhywfar-core-dev (>= 4.20.0~), libgwengui-qt5-dev (>= 4.20.0~),
  libgpgmepp-dev, libgpg-error-dev, libgpgme-dev,
  libalkimia5-dev (>= 7.0),
  libical-dev, libofx-dev, libgmp-dev,
